/** \mainpage Driver Overview
  *
  * \section section_drv_info Driver Information
  * This Sensor Controller Interface driver has been generated by the Texas Instruments Sensor Controller
  * Studio tool:
  * - <b>Project name</b>:     TIDA01228SRF06235UH
  * - <b>Project file</b>:     C:/ti/TI_Products/METERING_BU/2017_Milen/TIDA-LCSensing/TestBed8846EVM/LC_SRF06_VDDon_100pF235uH_4mmOK_8March17.scp
  * - <b>Code prefix</b>:      -
  * - <b>Operating system</b>: TI-RTOS
  * - <b>Tool version</b>:     1.4.0.42970
  * - <b>Tool patches</b>:     1 and 2
  * - <b>Target chip</b>:      CC1310, revision -, package QFN48 7x7 RGZ
  * - <b>Created</b>:          2017-03-13 11:05:33.502
  * - <b>Computer</b>:         LTA0797195A
  * - <b>User</b>:             a0797195
  *
  * The following user-provided resource definition(s) were used to generate this driver
  * - <b>Timer</b>: C:/Users/a0797195/Documents/Texas Instruments/Sensor Controller Studio/resource_defs/timer.red
  *
  * The following user-provided procedure definition(s) were used to generate this driver
  * - <b>evhSetupCompaTrigger()</b>: C:/Users/a0797195/Documents/Texas Instruments/Sensor Controller Studio/proc_defs/evh_setup_compa_trigger.prd
  * - <b>timerStart()</b>: C:/Users/a0797195/Documents/Texas Instruments/Sensor Controller Studio/proc_defs/timer_start.prd
  * - <b>timerStop()</b>: C:/Users/a0797195/Documents/Texas Instruments/Sensor Controller Studio/proc_defs/timer_stop.prd
  * - <b>timerWait()</b>: C:/Users/a0797195/Documents/Texas Instruments/Sensor Controller Studio/proc_defs/timer_wait.prd
  *
  * Do not edit the generated source code files other than temporarily for debug purposes. Any
  * modifications will be overwritten by the Sensor Controller Studio when generating new output.
  *
  * \section section_drv_modules Driver Modules
  * The driver is divided into three modules:
  * - \ref module_scif_generic_interface, providing the API for:
  *     - Initializing and uninitializing the driver
  *     - Task control (for starting, stopping and executing Sensor Controller tasks)
  *     - Task data exchange (for producing input data to and consume output data from Sensor Controller
  *       tasks)
  * - \ref module_scif_driver_setup, containing:
  *     - The AUX RAM image (Sensor Controller code and data)
  *     - I/O mapping information
  *     - Task data structure information
  *     - Driver setup data, to be used in the driver initialization
  *     - Project-specific functionality
  * - \ref module_scif_osal, for flexible OS support:
  *     - Interfaces with the selected operating system
  *
  * It is possible to use output from multiple Sensor Controller Studio projects in one application. Only
  * one driver setup may be active at a time, but it is possible to switch between these setups. When
  * using this option, there is one instance of the \ref module_scif_generic_interface and
  * \ref module_scif_osal modules, and multiple instances of the \ref module_scif_driver_setup module.
  * This requires that:
  * - The outputs must be generated using the same version of Sensor Controller Studio
  * - The outputs must use the same operating system
  * - The outputs must use different source code prefixes (inserted into all globals of the
  *   \ref module_scif_driver_setup)
  *
  *
  * \section section_project_info Project Description
  * No description entered
  *
  *
  * \subsection section_io_mapping I/O Mapping
  * Task I/O functions are mapped to the following pins:
  * - LCsense:
  *     - <b>AXD: Oscillation for Sensor 1</b>: DIO24
  *     - <b>AXD: Oscillation for Sensor2</b>: DIO25
  *     - <b>O: Kick the first LC sensor with PMOS FET </b>: DIO6
  *     - <b>O: Kick the 2nd LC sensor</b>: DIO7
  *
  *
  * \section section_task_info Task Description(s)
  * This driver supports the following task(s):
  *
  *
  * \subsection section_task_desc_lcsense LCsense
  * Excite 2 Sensors (L1 and L2), Metal detected =1; non-metal over L = 0;
  * L1old and L2old states are the Bits3 and 2 of a Pointer to a 16-bits long LUT (look-up table)
  * L1current and L2current states are Bits 1 and 0 of the Pointer to the LUT
  * After reading the LUT (UpCounter, DownCounter and Error bits) the L1old=L1current and L2old=L2current
  * 
  * Use "Analog Open-Drain Pins" rather than "Analog Pins", and then gpioClearOutput() to drive to GND
  * and gpioSetOutput() to stop driving.
  * ALWAYS MUST put the Output of the other L-sensor to GND, when exciting a LC-Sensor (this avoids
  * feedback from L1 to L2 when the Ls are a few mm away)
  *
  */




/** \addtogroup module_scif_driver_setup Driver Setup
  *
  * \section section_driver_setup_overview Overview
  *
  * This driver setup instance has been generated for:
  * - <b>Project name</b>:     TIDA01228SRF06235UH
  * - <b>Code prefix</b>:      -
  *
  * The driver setup module contains the generated output from the Sensor Controller Studio project:
  * - Location of task control and scheduling data structures in AUX RAM
  * - The AUX RAM image, and the size the image
  * - Task data structure information (location, size and buffer count)
  * - I/O pin mapping translation table
  * - Task resource initialization and uninitialization functions
  *
  * @{
  */
#ifndef SCIF_H
#define SCIF_H

#include <stdint.h>
#include <stdbool.h>
#include "scif_framework.h"
#include "scif_osal_tirtos.h"


/// Target chip name
#define SCIF_TARGET_CHIP_NAME_CC1310
/// Target chip package
#define SCIF_TARGET_CHIP_PACKAGE_QFN48_7X7_RGZ

/// Number of tasks implemented by this driver
#define SCIF_TASK_COUNT 1

/// LCsense: Task ID
#define SCIF_LCSENSE_TASK_ID 0


/// LCsense: Length of Tables for counters (Up,down, error)
#define SCIF_LCSENSE_LUT 16
/// LCsense: How many sensors are used
#define SCIF_LCSENSE_SENSORS 2
/// LCsense: Delta of TDC ticks between nonMetal and Metal 
#define SCIF_LCSENSE_SENSOR_THRSD 8
/// LCsense: Count of TDC ticks with nonMetal over Sensor Inductor
#define SCIF_LCSENSE_TICKS_NONMETAL1 2506
/// LCsense: Counts ticks
#define SCIF_LCSENSE_TICKS_NONMETAL2 2339
/// LCsense I/O mapping: Oscillation for Sensor 1
#define SCIF_LCSENSE_DIO_AXD_LC_OUTP1 24
/// LCsense I/O mapping: Oscillation for Sensor2
#define SCIF_LCSENSE_DIO_AXD_LC_OUTP2 25
/// LCsense I/O mapping: Kick the first LC sensor with PMOS FET 
#define SCIF_LCSENSE_DIO_O_FLOW_TRIG1 6
/// LCsense I/O mapping: Kick the 2nd LC sensor
#define SCIF_LCSENSE_DIO_O_FLOW_TRIG2 7


// All shared data structures in AUX RAM need to be packed
#pragma pack(push, 2)


/// LCsense: Task output data structure
typedef struct {
    uint16_t counter;     ///< 
    uint16_t downCounter; ///< Counts anti-clockwise state changes for Application on M3 core 
    int16_t  effCounter;  ///< Effective result for forward and backwards rotation to pass to M3
    uint16_t tdcValueL1;  ///< Number of TDC ticks per Sensor S1 measurement
    uint16_t tdcValueL2;  ///< Number of TDC ticks per Sensor S2 measurement
    uint16_t upCounter;   ///< UpCounter for Application on M3 core 
} SCIF_LCSENSE_OUTPUT_T;


/// LCsense: Task state structure
typedef struct {
    uint16_t CurrentState;    ///< Sensor states in the current position
    uint16_t PreviousState;   ///< Previous State for S1S2 sensors
    uint16_t SensorL1;        ///< 0 means plastic or air, 1 means metal infront of sensor1
    uint16_t SensorL2;        ///< 0 means plastic or air, 1 means metal infront of sensor1
    uint16_t counter;         ///< Incremented each time the driver is alerted
    uint16_t downCounter;     ///< anti-clockwise
    int16_t  effCounter;      ///< the Sum of Up and Down Counters
    uint16_t errorLUT[16];    ///< Errors in state transitions
    uint16_t init;            ///< Very first sensing to determine initial disc position
    uint16_t minusOneLUT[16]; ///< Rotate counterclockwise
    uint16_t plusOneLUT[16];  ///< Rotate clockwise (forward)
    uint16_t upCounter;       ///< Clockwise
} SCIF_LCSENSE_STATE_T;


/// Sensor Controller task data (configuration, input buffer(s), output buffer(s) and internal state)
typedef struct {
    struct {
        SCIF_LCSENSE_OUTPUT_T output;
        SCIF_LCSENSE_STATE_T state;
    } lcsense;
} SCIF_TASK_DATA_T;

/// Sensor Controller task generic control (located in AUX RAM)
#define scifTaskData    (*((volatile SCIF_TASK_DATA_T*) 0x400E00E8))


// Initialized internal driver data, to be used in the call to \ref scifInit()
extern const SCIF_DATA_T scifDriverSetup;


// Restore previous struct packing setting
#pragma pack(pop)


// AUX I/O re-initialization functions
void scifReinitTaskIo(uint32_t bvTaskIds);


// RTC-based tick generation control
void scifStartRtcTicks(uint32_t tickStart, uint32_t tickPeriod);
void scifStartRtcTicksNow(uint32_t tickPeriod);
void scifStopRtcTicks(void);


#endif
//@}


// Generated by LTA0797195A at 2017-03-13 11:05:33.502
